<?php
/*
Plugin Name: WordPress Gallery Slideshow
Plugin URI: http://thomas.stachl.me/plugins/wordpress-gallery-slideshow/
Description: This plugin adds the JW Image Rotator to the WordPress Media.
Version: 1.3.1
Author: Thomas Stachl
Author URI: http://thomas.stachl.me/

Change Log:
1.3.1
	Added order tag to slideshow you can now order ASC or DESC
	
1.3
	Added the audio function to play audio while playing the slideshow

1.2.5
	Added the theme function (wp_gallery_slideshow)
	Made compatible to previous versions


    Copyright 2008 Thomas Stachl  (email : thomas@stachl.me)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


error_reporting(E_ERROR);

if( isset($_GET['resource']) && !empty($_GET['resource'])) {
	# base64 encoding
	$resources = array(
		'icon.gif' =>
		'R0lGODlhEAAOAMQAAEtLS9bW1rW1tYqKiubm5nx8fMbGxllZWf'.
		'f396ampnNzc97e3szMzJmZme/v77+/v////21tbYKCgq2trVFR'.
		'UZGRkf///wAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACH5BA'.
		'EHABYALAAAAAAQAA4AAAWHoCWOpIU4i1OK0EkQSxAQImI7sMww'.
		'jxEslleAJygKJkiBzIITJBiBiTGRUAZMhCIC4jAWDokFAxH0OY'.
		'ZFiQJA2ZHPgsqhImhIJAdAIqBCLAZ4FHYSBQAADT8mCxUFaxEF'.
		'Aw0NDwE+IgQJCgUVEz4yBg8MNGUCUJWhfGQjDjtQKRArNaKwsS'.
		'IhADs='.
		'');
 
	if(array_key_exists($_GET['resource'], $resources)) {
 
		$content = base64_decode($resources[ $_GET['resource'] ]);
 
		$lastMod = filemtime(__FILE__);
		$client = ( isset($_SERVER['HTTP_IF_MODIFIED_SINCE']) ? $_SERVER['HTTP_IF_MODIFIED_SINCE'] : false );
		// Checking if the client is validating his cache and if it is current.
		if (isset($client) && (strtotime($client) == $lastMod)) {
			// Client's cache IS current, so we just respond '304 Not Modified'.
			header('Last-Modified: '.gmdate('D, d M Y H:i:s', $lastMod).' GMT', true, 304);
			exit;
		} else {
			// Image not cached or cache outdated, we respond '200 OK' and output the image.
			header('Last-Modified: '.gmdate('D, d M Y H:i:s', $lastMod).' GMT', true, 200);
			header('Content-Length: '.strlen($content));
			header('Content-Type: image/' . substr(strrchr($_GET['resource'], '.'), 1) );
			echo $content;
			exit;
		}
	}
}

function wp_gallery_slideshow_get_resource_url($resourceID) {
	return trailingslashit( get_bloginfo('url') ) . '?resource=' . $resourceID;
}

// Localization
load_plugin_textdomain('wordpress-gallery-slideshow');

// Load farbtastic
wp_enqueue_script('farbtastic');
wp_enqueue_style('farbtastic');

// Global plugin url
$gs_plugin_url = trailingslashit( get_bloginfo('wpurl') ).PLUGINDIR.'/'. dirname( plugin_basename(__FILE__) );

// Hook for adding menupage
if ( is_admin() ) {
	add_action('admin_menu', 'wp_gallery_slideshow_add_page');
}

// Function for above hook
function wp_gallery_slideshow_add_page() {
	global $wp_version;
	if ( current_user_can('edit_posts') && function_exists('add_submenu_page') ) {
 
		$menutitle = '';
		if ( version_compare( $wp_version, '2.6.999', '<' ) ) {
			$page = 'options-general.php';
		} elseif ( $wp_version == '2.7-beta3' ) {
			$menutitle = '<img src="' . wp_gallery_slideshow_get_resource_url('icon.gif') . '" alt="" />' . ' ';
			$page = 'media-new.php';
		} else {
			$menutitle = '<img src="' . wp_gallery_slideshow_get_resource_url('icon.gif') . '" alt="" />' . ' ';
			$page = 'upload.php';
		}
		$menutitle .= __('Slideshow', 'wordpress-gallery-slideshow');
 		
		add_submenu_page($page, __('WordPress Gallery Slideshow', 'wordpress-gallery-slideshow'), $menutitle, 9, __FILE__, 'wp_gallery_slideshow_options');
		$plugin = plugin_basename(__FILE__); 
		add_filter( 'plugin_action_links_' . $plugin, 'wp_gallery_slideshow_plugin_actions' );
	}
}

// Adds an action link to the plugins page
function wp_gallery_slideshow_plugin_actions($links) {
	if ( version_compare( $wp_version, '2.6.999', '<' ) )
		$page = 'options-general.php';
	elseif ( $wp_version == '2.7-beta3' )
		$page = 'media-new.php';
	else
		$page = 'upload.php';
	$settings_link = '<a href="'.$page.'?page=wordpress-gallery-slideshow/wp-gallery-slideshow.php">' . __('Settings') . '</a>';
	array_unshift( $links, $settings_link );
 
	return $links;
}

// Displays the page content for the Slideshow Options submenu
function wp_gallery_slideshow_options() {
	global $gs_plugin_url;
    if(isset($_POST['action'])) {
		if($_POST['shuffle']) $_POST['shuffle'] = 'true'; else  $_POST['shuffle'] = 'false';
		if($_POST['searchbar']) $_POST['searchbar'] = 'true'; else $_POST['searchbar'] = 'false';
		if($_POST['overstretch']) $_POST['overstretch'] = 'true'; else  $_POST['overstretch'] = 'false';
		if($_POST['shownavigation']) $_POST['shownavigation'] = 'true'; else  $_POST['shownavigation'] = 'false';
		if($_POST['usefullscreen']) $_POST['usefullscreen'] = 'true'; else  $_POST['usefullscreen'] = 'false';
		if($_POST['autostart']) $_POST['autostart'] = 'true'; else  $_POST['autostart'] = 'false';
		if($_POST['ad']) $_POST['ad'] = 'true'; else  $_POST['ad'] = 'false';
		if(!is_numeric($_POST['rotatetime'])) $_POST['rotatetime'] = '5';
		
		$settings = array (
			'height'			=> $_POST['height'],
			'width'				=> $_POST['width'],
			'backcolor'			=> substr($_POST['backcolor'], -6),
			'frontcolor'		=> substr($_POST['frontcolor'], -6),
			'lightcolor'		=> substr($_POST['lightcolor'], -6),
			'screencolor'		=> substr($_POST['screencolor'], -6),
			'logo'				=> $_POST['logo'],
			'transition'		=> $_POST['transition'],
			'rotatetime'		=> intval($_POST['rotatetime']),
			'shuffle'			=> $_POST['shuffle'],
			'searchbar'			=> $_POST['searchbar'],
			'overstretch'		=> $_POST['overstretch'],
			'shownavigation'	=> $_POST['shownavigation'],
			'usefullscreen'		=> $_POST['usefullscreen'],
			'autostart'			=> $_POST['autostart'],
		);
		update_option('wp_gallery_slideshow', $settings);

		echo "<div id=\"message\" class=\"updated fade\"><p><strong>WordPress Gallery Slideshow plugin options updated.</strong></p></div>";
    }

	$settings = get_option('wp_gallery_slideshow');
	
	$height = $settings['height'];
	$width = $settings['width'];
	$backcolor = $settings['backcolor'];
	$frontcolor = $settings['frontcolor'];
	$lightcolor = $settings['lightcolor'];
	$screencolor = $settings['screencolor'];
	$logo = $settings['logo'];
	$transition = $settings['transition'];
	$rotatetime = $settings['rotatetime'];
	$shuffle = $settings['shuffle'];
	$searchbar = $settings['searchbar'];
	$overstretch = $settings['overstretch'];
	$shownavigation = $settings['shownavigation'];
	$usefullscreen = $settings['usefullscreen'];
	$autostart = $settings['autostart'];
		
	$actionurl=$_SERVER['REQUEST_URI'];

?>
<script type="text/javascript">
	jQuery(document).ready(function() {
		jQuery('#colorpicker_back').farbtastic('#backcolor');
		jQuery('#colorpicker_light').farbtastic('#lightcolor');
		jQuery('#colorpicker_front').farbtastic('#frontcolor');
		jQuery('#colorpicker_screen').farbtastic('#screencolor');
		jQuery('#backcolor').focus( function(){
			jQuery('#colorpicker_back').show();
		});
		jQuery('#backcolor').blur( function(){
			jQuery('#colorpicker_back').hide();
		});
		jQuery('#lightcolor').focus( function(){
			jQuery('#colorpicker_light').show();
		});
		jQuery('#lightcolor').blur( function(){
			jQuery('#colorpicker_light').hide();
		});
		jQuery('#frontcolor').focus( function(){
			jQuery('#colorpicker_front').show();
		});
		jQuery('#frontcolor').blur( function(){
			jQuery('#colorpicker_front').hide();
		});
		jQuery('#screencolor').focus( function(){
			jQuery('#colorpicker_screen').show();
		});
		jQuery('#screencolor').blur( function(){
			jQuery('#colorpicker_screen').hide();
		});
	});
</script>
<div class="wrap" style="max-width:950px !important;"> 
	<h2><?php _e('WordPress Gallery Slideshow', 'wordpress-gallery-slideshow'); ?></h2> 
				
	<div id="poststuff" style="margin-top:10px;"> 
		<div id="sideblock" style="float:right;width:220px;margin-left:10px;"> 
				 <h3><?php _e('Information', 'wordpress-gallery-slideshow'); ?></h3> 
				 <div id="dbx-content" style="text-decoration:none;"> 
					 <img src="<?php echo $gs_plugin_url ?>/images/browser_16x16.png"><a style="text-decoration:none;" href="http://thomas.stachl.me/2008/11/29/tutorials/wordpress-gallery-slideshow/"> <?php _e('Plugin Home', 'wordpress-gallery-slideshow'); ?></a><br /><br /> 
					 <img src="<?php echo $gs_plugin_url ?>/images/notes_16x16.png"><a style="text-decoration:none;" href="http://thomas.stachl.me/2008/11/29/tutorials/wordpress-gallery-slideshow/#comments"> <?php _e('Plugin Comments', 'wordpress-gallery-slideshow'); ?></a><br /><br /> 
					 <img src="<?php echo $gs_plugin_url ?>/images/wallpaper_16x16.png"><a style="text-decoration:none;" href="http://wordpress.org/extend/plugins/wordpress-gallery-slideshow/"> <?php _e('Rate Plugin', 'wordpress-gallery-slideshow'); ?></a><br /><br /> 
				     <img src="<?php echo $gs_plugin_url ?>/images/map_16x16.png"><a style="text-decoration:none;" href="http://thomas.stachl.me/plugins/"> <?php _e('My WordPress Plugins', 'wordpress-gallery-slideshow'); ?></a><br /><br /> 
					 <br /> 
					 <p align="center"><img src="<?php echo $gs_plugin_url ?>/images/tools_128x128.png" width="128" height="128"></p> 
					 <p><img src="<?php echo $gs_plugin_url ?>/images/mail_16x16.png"><a style="text-decoration:none;" href="http://thomas.stachl.me/kontakt/"> <?php _e('Contact me', 'wordpress-gallery-slideshow'); ?></a></p> 
		 			 <br />
                     <br />
                	 <p align="center">
                     	<form action="https://www.paypal.com/cgi-bin/webscr" method="post" class="donate">
                        	<input type="hidden" name="amount" value="1.00"/>
                            <input type="hidden" name="cmd" value="_xclick"/>
                            <input type="hidden" name="business" value="thomas@stachl.me"/>
                            <input type="hidden" name="item_name" value="Donate for the work of thomas.stachl.me"/>
                            <input type="hidden" name="no_shipping" value="1"/>
                            <input type="hidden" name="return" value="<?php echo $gs_plugin_url ?>/wp-gallery-slideshow.php"/>
                            <input type="hidden" name="cancel_return" value="http://thomas.stachl.me"/>
                            <input type="hidden" name="currency_code" value="EUR"/>
                            <input type="hidden" name="tax" value="0"/>
                            <input type="image" src="<?php echo $gs_plugin_url ?>/images/donate.png" style="border: 0pt none ;" name="submit" alt="PayPal - The safer, easier way to pay online"/>
                        </form>
                     </p>
                     <p>Every donation is gratefully accepted and allows the continued work on free software.</p>
                </div> 
		 	</div> 
 
	 <div id="mainblock" style="width:710px"> 
	 
		<div class="dbx-content"> 
		 	<form action="<?php echo $actionurl; ?>" method="post"> 
					<input type="hidden" name="action" value="update" />
					<?php wp_nonce_field('update-options'); ?>
					<h3><?php _e('Options', 'wordpress-gallery-slideshow'); ?></h3>		
			  <p><?php _e('Enter the default settings for JW Image Rotation.', 'wordpress-gallery-slideshow'); ?></p>
                    <fieldset>
                    <legend><?php _e('Dimension', 'wordpress-gallery-slideshow'); ?></legend>
                        <table width="450" border="0" cellpadding="0" cellspacing="0" class="form-table">
                            <tr valign="top">
                              <td width="225"><input type="text" name="width" value="<?php echo $width; ?>" />
                                <label for="width"> <?php _e('Width', 'wordpress-gallery-slideshow'); ?></label></td>
                              <td width="225"><input type="text" name="height" value="<?php echo $height; ?>" />
                                <label for="height"> <?php _e('Height', 'wordpress-gallery-slideshow'); ?></label></td>
                            </tr>
                        </table>
                    </fieldset>
					<br />					
					<br /> 				
                    <fieldset>
                    <legend><?php _e('Colors', 'wordpress-gallery-slideshow'); ?></legend>
                    <table width="450" border="0" cellpadding="0" cellspacing="0" class="form-table">
                        <tr valign="top">
                            <td width="225"><input type="text" name="backcolor" id="backcolor" value="#<?php echo $backcolor; ?>" onfocus="" />
                                <label for="backcolor"> <?php _e('Backcolor', 'wordpress-gallery-slideshow'); ?></label><div id="colorpicker_back" style="background:#FFFFFF;position:absolute;display:none;"></div></td>
                            <td width="225"><input type="text" name="lightcolor" id="lightcolor" value="#<?php echo $lightcolor; ?>" onfocus="" />
                                <label for="lightcolor"> <?php _e('Lightcolor', 'wordpress-gallery-slideshow'); ?></label><div id="colorpicker_light" style="background:#FFFFFF;position:absolute;display:none;"></div></td>
                        </tr>
                        <tr valign="top">
                            <td width="225"><input type="text" name="frontcolor" id="frontcolor" value="#<?php echo $frontcolor; ?>" onfocus="" />
                                <label for="frontcolor"> <?php _e('Frontcolor', 'wordpress-gallery-slideshow'); ?></label><div id="colorpicker_front" style="background:#FFFFFF;position:absolute;display:none;"></div></td>
                            <td width="225"><input type="text" name="screencolor" id="screencolor" value="#<?php echo $screencolor; ?>" onfocus="" />
                                <label for="screencolor"> <?php _e('Screencolor', 'wordpress-gallery-slideshow'); ?></label><div id="colorpicker_screen" style="background:#FFFFFF;position:absolute;display:none;"></div></td>
                        </tr>
                    </table>
                    </fieldset>
					<br />
                    <br />
                    <fieldset>
                    <legend><?php _e('Various', 'wordpress-gallery-slideshow'); ?></legend>	
                    <table width="450" border="0" cellpadding="0" cellspacing="0" class="form-table">
                        <tr valign="top">
                            <td width="225"><input type="text" name="logo" value="<?php echo $logo; ?>" />
                                <label for="logo"> <?php _e('Watermark', 'wordpress-gallery-slideshow'); ?></label></td>
                            <td width="225"><input type="text" name="rotatetime" value="<?php echo $rotatetime; ?>" />
                                <label for="rotatetime"> <?php _e('Rotatetime', 'wordpress-gallery-slideshow'); ?></label></td>
                        </tr>
                        <tr valign="top">
                            <td width="225">
                                <input name="shuffle" type="checkbox"<?php if($shuffle == 'true') echo ' checked="checked"'; ?> /><label for="shuffle"> <?php _e('Randomly choosen picture', 'wordpress-gallery-slideshow'); ?></label>  <br />
                                <input name="searchbar" type="checkbox"<?php if($searchbar == 'true') echo ' checked="checked"'; ?> /><label for="searchbar"> <?php _e('Show searchbar', 'wordpress-gallery-slideshow'); ?></label>  <br />
                                <input name="overstretch" type="checkbox"<?php if($overstretch == 'true') echo ' checked="checked"'; ?> /><label for="overstretch"> <?php _e('Overstretch', 'wordpress-gallery-slideshow'); ?></label>  <br />
                                <input name="shownavigation" type="checkbox"<?php if($shownavigation == 'true') echo ' checked="checked"'; ?> /><label for="shownavigation"> <?php _e('Show navigation', 'wordpress-gallery-slideshow'); ?></label>  <br />
                                <input name="usefullscreen" type="checkbox"<?php if($usefullscreen == 'true') echo ' checked="checked"'; ?> /><label for="usefullscreen"> <?php _e('Enable fullscreen mode', 'wordpress-gallery-slideshow'); ?></label>  <br />
                                <input name="autostart" type="checkbox"<?php if($autostart == 'true') echo ' checked="checked"'; ?> /><label for="autostart"> <?php _e('Start slideshow automatically', 'wordpress-gallery-slideshow'); ?></label>  <br />
                    		</td>
                            <td width="225"><select name="transition">
                                                <option value="random"<?php if ($transition=='random') echo ' selected="selected"'; ?>><?php _e('Random', 'wordpress-gallery-slideshow'); ?></option>
                                                <option value="fade"<?php if ($transition=='fade') echo ' selected="selected"'; ?>><?php _e('Fade', 'wordpress-gallery-slideshow'); ?></option>
                                                <option value="bgfade"<?php if ($transition=='bgfade') echo ' selected="selected"'; ?>><?php _e('Background Fade', 'wordpress-gallery-slideshow'); ?></option>
                                                <option value="blocks"<?php if ($transition=='blocks') echo ' selected="selected"'; ?>><?php _e('Blocks', 'wordpress-gallery-slideshow'); ?></option>
                                                <option value="bubbles"<?php if ($transition=='bubbles') echo ' selected="selected"'; ?>><?php _e('Bubbles', 'wordpress-gallery-slideshow'); ?></option>
                                                <option value="circles"<?php if ($transition=='circles') echo ' selected="selected"'; ?>><?php _e('Circles', 'wordpress-gallery-slideshow'); ?></option>
                                                <option value="flash"<?php if ($transition=='flash') echo ' selected="selected"'; ?>><?php _e('Flash', 'wordpress-gallery-slideshow'); ?></option>
                                                <option value="fluids"<?php if ($transition=='fluids') echo ' selected="selected"'; ?>><?php _e('Fluids', 'wordpress-gallery-slideshow'); ?></option>
                                                <option value="lines"<?php if ($transition=='lines') echo ' selected="selected"'; ?>><?php _e('Lines', 'wordpress-gallery-slideshow'); ?></option>
                                                <option value="slowfade"<?php if ($transition=='slowfade') echo ' selected="selected"'; ?>><?php _e('Slowfade', 'wordpress-gallery-slideshow'); ?></option>
                                            </select>
                                <label for="transition"> <?php _e('Transition', 'wordpress-gallery-slideshow'); ?></label></td>
                        </tr>
                    </table>
					</fieldset>
                    <br />
                    <br />																								
					<div class="submit"><input type="submit" name="Submit" value="<?php _e('Save Changes') ?>" /></div> 
			</form> 
		</div> 
				
	<br/><br/><h3>&nbsp;</h3>	
	 </div> 
 
	</div> 
	
<h5><?php _e('WordPress Gallery Slideshow plugin by ', 'wordpress-gallery-slideshow'); ?><a href="http://thomas.stachl.me/">Thomas Stachl</a></h5> 
</div> 
<?php
}

// Overrides the shortcut function for [gallery]
function wp_gallery_slideshow_shortcut($attr) {
	global $post;
	global $gs_plugin_url;
	global $wp_version;
	
	$settings = get_option('wp_gallery_slideshow');
	
	$height = $settings['height'];
	$width = $settings['width'];
	$backcolor = $settings['backcolor'];
	$frontcolor = $settings['frontcolor'];
	$lightcolor = $settings['lightcolor'];
	$screencolor = $settings['screencolor'];
	$logo = $settings['logo'];
	$transition = $settings['transition'];
	$rotatetime = $settings['rotatetime'];
	$shuffle = $settings['shuffle'];
	$searchbar = $settings['searchbar'];
	$overstretch = $settings['overstretch'];
	$shownavigation = $settings['shownavigation'];
	$usefullscreen = $settings['usefullscreen'];
	$autostart = $settings['autostart'];

	// Allow plugins/themes to override the default gallery template.
	/*$output = apply_filters('post_gallery', '', $attr);
	if ( $output != '' )
		return $output;
	*/
	// We're trusting author input, so let's at least make sure it looks like a valid orderby statement
	if ( isset( $attr['orderby'] ) ) {
		$attr['orderby'] = sanitize_sql_orderby( $attr['orderby'] );
		if ( !$attr['orderby'] )
			unset( $attr['orderby'] );
	}

	extract(shortcode_atts(array(
		'order'      		=> 'ASC',
		'orderby'    		=> 'menu_order ID',
		'id'         		=> $post->ID,
		'itemtag'    		=> 'dl',
		'icontag'    		=> 'dt',
		'captiontag' 		=> 'dd',
		'columns'    		=> 3,
		'size'       		=> 'thumbnail',
		'slide'		 		=> 0,
		'height'	 		=> $height,
		'width'		 		=> $width,
		'backcolor'	 		=> $backcolor,
		'frontcolor' 		=> $frontcolor,
		'lightcolor' 		=> $lightcolor,
		'screencolor'		=> $screencolor,
		'logo'		 		=> $logo,
		'transition' 		=> $transition,
		'rotatetime' 		=> $rotatetime,
		'shuffle'	 		=> $shuffle,
		'searchbar'	 		=> $searchbar,
		'overstretch'		=> $overstretch,
		'shownavigation'	=> $shownavigation,
		'usefullscreen'		=> $usefullscreen,
		'autostart'			=> $autostart,
		'flickr'			=> '',
		'audio'				=> '',
	), $attr));

	$id = intval($id);
	
	if ( !$slide ) {
		$attachments = get_children( array('post_parent' => $id, 'post_status' => 'inherit', 'post_type' => 'attachment', 'post_mime_type' => 'image', 'order' => $order, 'orderby' => $orderby) );
	
		if ( empty($attachments) )
			return '';
	
		if ( is_feed() ) {
			$output = "\n";
			foreach ( $attachments as $id => $attachment )
				$output .= wp_get_attachment_link($id, $size, true) . "\n";
			return $output;
		}
	
		$itemtag = tag_escape($itemtag);
		$captiontag = tag_escape($captiontag);
		$columns = intval($columns);
		$slide = intval($slide);
		$itemwidth = $columns > 0 ? floor(100/$columns) : 100;
		$output = apply_filters('gallery_style', "
			<style type='text/css'>
				.gallery {
					margin: auto;
				}
				.gallery-item {
					float: left;
					margin-top: 10px;
					text-align: center;
					width: {$itemwidth}%;			}
				.gallery img {
					border: 2px solid #cfcfcf;
				}
				.gallery-caption {
					margin-left: 0;
				}
			</style>
			<div class='gallery'>");
	
		$i = 0;
		foreach ( $attachments as $id => $attachment ) {
			$link = wp_get_attachment_link($id, $size, true);
			$output .= "<{$itemtag} class='gallery-item'>";
			$output .= "
				<{$icontag} class='gallery-icon'>
					$link
				</{$icontag}>";
			if ( $captiontag && trim($attachment->post_excerpt) ) {
				$output .= "
					<{$captiontag} class='gallery-caption'>
					{$attachment->post_excerpt}
					</{$captiontag}>";
			}
			$output .= "</{$itemtag}>";
			if ( $columns > 0 && ++$i % $columns == 0 )
				$output .= '<br style="clear: both" />';
		}
		$output .= "
				<br style='clear: both;' />
			</div>\n";
	} else {
		$attr = "attr=id*$id";
		
		if ($order)
			$attr .= "%order*$order";
		if ($flickr) {
			$flickr = urlencode($flickr);
			$attr = "%flickr#$flickr";
		}
		if (!$audio == '')
			$audio = "&amp;audio=".urlencode($audio);
			
        $output = "
			<div class='slideshow'>
				<object width='$width' height='$height' data='$gs_plugin_url/imagerotator.swf' type='application/x-shockwave-flash'>
					<param value='$gs_plugin_url/imagerotator.swf' name='movie'/>
					<param value='$usefullscreen' name='allowFullScreen'/>
					<param value='transparent' name='wmode'/>
					<param value='$width' name='width'/>
					<param value='$height' name='height'/>
					<param value='file=$gs_plugin_url/getxml.php?$attr$audio&amp;rotatetime=$rotatetime&amp;autostart=$autostart&amp;backcolor=0x$backcolor&amp;frontcolor=0x$frontcolor&amp;lightcolor=0x$lightcolor&amp;screencolor=0x$screencolor&amp;logo=$logo&amp;transition=$transition&amp;shuffle=$shuffle&amp;searchbar=$searchbar&amp;overstretch=$overstretch&amp;shownavigation=$shownavigation' name='flashvars'/>
				</object>
				<a href='http://thomas.stachl.me/'></a>
			</div>\n";
	}

	return $output;
}
add_shortcode('gallery', 'wp_gallery_slideshow_shortcut');

function wp_gallery_slideshow($attr = '') {
	$result = '';
	$attr .= "&slide=1";
	$attributes = explode('&', $attr);
		foreach($attributes as $attribute){
			if($attribute){
				// find the position of the first '='
				$i = strpos($attribute, '=');
				// if not a valid format ('key=value) we ignore it
				if ($i){
					$key = substr($attribute, 0, $i);
					$val = substr($attribute, $i+1); 
					$result[$key]=$val;
				}
			}
		}
	echo wp_gallery_slideshow_shortcut($result);
}

function wp_gallery_slideshow_uninstall(){
	delete_option('wp_gallery_slideshow');
}
register_deactivation_hook( __FILE__, 'wp_gallery_slideshow_uninstall' );

function wp_gallery_slideshow_install(){
	$settings = array (
			'height'			=> 260,
			'width'				=> 320,
			'backcolor'			=> 'FFFFFF',
			'frontcolor'		=> '000000',
			'lightcolor'		=> '000000',
			'screencolor'		=> '000000',
			'logo'				=> '',
			'transition'		=> 'random',
			'rotatetime'		=> 5,
			'shuffle'			=> 'false',
			'searchbar'			=> 'true',
			'overstretch'		=> 'false',
			'shownavigation'	=> 'true',
			'usefullscreen'		=> 'true',
			'autostart'			=> 'true',
		);
		
	if(!get_option('wp_gallery_slideshow')){
		add_option('wp_gallery_slideshow', $settings);
	}
}
register_activation_hook( __FILE__, 'wp_gallery_slideshow_install' );

?>